var fc = {};
fc.on = function(obj, event, func){
//	$(document).off(event, obj).on(event, obj, func);
	mui(document).off(event, obj).on(event, obj, func);
};

// 对mui以及nativejs相关封装
//fc = {};

// page相关
fc.normalStyle = {top:'0px',bottom:0,scrollIndicator:"none"};
fc.normalPage = function(id){
	return fc.page(id, {styles : fc.normalStyle});
};
fc.centerStyle = {top:'0px',bottom:'50px',scrollIndicator:"none"};
fc.centerPage = function(id){
	return fc.page(id, {styles:fc.centerStyle});
};
fc.page = function(id, options){
	var url = id + '.html';
	options.id = id;
	options.url = url;
	return options;
};
fc.indexPage = function(){
	return plus.webview.getWebviewById(plus.runtime.appid);
};
fc.currentPage = function(){
	return plus.webview.currentWebview();
};
fc.getPage = function(id){
	return id ? plus.webview.getWebviewById(id) : null;
};
fc.show = function(id, ani, time, func){
	if(id) plus.webview.show(id, ani, time, func);
};
fc.hide = function(id, ani, time){
	if(id) plus.webview.hide(id, ani, time);
};
fc.fire = function(id, name, values){
	mui.fire(fc.getPage(id), name, values);
};

// 以下为UI封装------------------------------------------------------------------------------
// nativeui相关
fc.tip = function(msg, options){
	plus.nativeUI.toast(msg,options);
};
fc.waiting = function(titile, options){
	plus.nativeUI.showWaiting(titile, options);
};
fc.closeWaiting = function(){
	plus.nativeUI.closeWaiting();
};

// popover
fc.pop = function(){
	mui('.mui-popover').popover('toggle');
};

// actionsheet
fc.sheet = function(title, btns,func){
	if(title && btns && btns.length > 0){
		var btnArray = [];
		for(var i=0; i<btns.length; i++){
			btnArray.push({title:btns[i]});
		}
		
		plus.nativeUI.actionSheet({
			title : title,
			cancel : '取消',
			buttons : btnArray
		}, function(e){
			if(func) func(e);
		});
	}
};

// 提示框相关
fc.modaloptions = {
	title 	: 'title',
	abtn	: '确定',
	cbtn	: ['确定','取消'],
	content	: 'content'
};
fc.alert = function(options, ok){
	var opt = $.extend({}, fc.modaloptions);
	
	opt.title = '提示';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}
	
	plus.nativeUI.alert(opt.content, function(e){
		if(ok) ok();
	}, opt.title, opt.abtn);
};
fc.confirm = function(options, ok, cancel){
	var opt = $.extend({}, fc.modaloptions);
	
	opt.title = '确认操作';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}
	
	plus.nativeUI.confirm(opt.content, function(e){
		var i = e.index;
		if(i == 0 && ok) ok();
		if(i == 1 && cancel) cancel();
	}, opt.title, opt.cbtn);
};
fc.prompt = function(options, ok, cancel){
	var opt = $.extend({}, fc.modaloptions);
	
	opt.title = '输入内容';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}
	
	plus.nativeUI.prompt(opt.content, function(e){
		var i = e.index;
		if(i == 0 && ok) ok(e.value);
		if(i == 1 && cancel) cancel(e.value);
	}, opt.title, opt.content, opt.cbtn);
};

// 以下为插件封装------------------------------------------------------------------------------
// 本地存储相关
fc.length = function(){
	return plus.storage.getLength();
};
fc.key = function(i){
	return plus.storage.key(i);
};
fc.getItem = function(key){
	if(key){
		for(var i=0; i<fc.length(); i++) {
			if(key == plus.storage.key(i)){
				return plus.storage.getItem(key);
			}
		};
	}
	return null;
};
fc.insertItem = function(key, value){
	plus.storage.setItem(key, value);
};
fc.delItem = function(key){
	plus.storage.removeItem(key);
};
fc.clear = function(){
	plus.storage.clear();
};

// web sql
fc.db = function(name, size){
	var db_name = name ? name : 'db_test';
	var db_size = size ? size : 2;
	
	return openDatabase(db_name, '1.0', 'db_test', db_size * 1024 * 1024);
};
fc.update = function(db, sql){
	if(db &&sql) db.transaction(function(tx){tx.executeSql(sql);});
};
fc.query = function(db, sql, func){
	if(db && sql){
		db.transaction(function(tx){
			tx.executeSql(sql, [], function(tx, results) {
				func(results);
			}, null);
		});
	}
};

// 以下为功能封装------------------------------------------------------------------------------
// 退出
fc.exit = function(){
	fc.confirm('确定要退出吗？', function(){
		plus.runtime.quit();
	});
};
// 刷新
fc.endDown = function(selector){
	var sel = selector ? selector : '#refreshContainer';
	mui(sel).pullRefresh().endPulldownToRefresh();
};

// 以下扩展JS原生方法------------------------------------------------------------------------------

fc.addClass = function(obj, cls){
    var obj_class = obj.className,//获取 class 内容.
    blank = (obj_class != '') ? ' ' : '';//判断获取到的 class 是否为空, 如果不为空在前面加个'空格'.
    added = obj_class + blank + cls;//组合原来的 class 和需要添加的 class.
    obj.className = added;//替换原来的 class.
}
 
fc.removeClass = function(obj, cls){
    var obj_class = ' '+obj.className+' ';//获取 class 内容, 并在首尾各加一个空格. ex) 'abc        bcd' -> ' abc        bcd '
    obj_class = obj_class.replace(/(\s+)/gi, ' '),//将多余的空字符替换成一个空格. ex) ' abc        bcd ' -> ' abc bcd '
    removed = obj_class.replace(' '+cls+' ', ' ');//在原来的 class 替换掉首尾加了空格的 class. ex) ' abc bcd ' -> 'bcd '
    removed = removed.replace(/(^\s+)|(\s+$)/g, '');//去掉首尾空格. ex) 'bcd ' -> 'bcd'
    obj.className = removed;//替换原来的 class.
}


